<!DOCTYPE html>
<html>
<head>
	<title>GeoJSON Map</title>
<head>
	<link rel="stylesheet" href="https://unpkg.com/leaflet@1.0.3/dist/leaflet.css" integrity="sha512-07I2e+7D8p6he1SIM+1twR5TIrhUQn9+I6yjqD53JQjFiMf8EtC93ty0/5vJTZGF8aAocvHYNEDJajGdNx1IsQ=="
		crossorigin="" />
	<script src="https://unpkg.com/leaflet@1.0.3/dist/leaflet.js" integrity="sha512-A7vV8IFfih/D732iSSKi20u/ooOfj/AGehOKq0f4vLT1Zr2Y+RX7C+w8A1gaSasGtRUZpF/NZgzSAu4/Gc41Lg=="
		crossorigin=""></script>
	<script src="https://unpkg.com/esri-leaflet@2.5.0/dist/esri-leaflet.js" integrity="sha512-ucw7Grpc+iEQZa711gcjgMBnmd9qju1CICsRaryvX7HJklK0pGl/prxKvtHwpgm5ZHdvAil7YPxI1oWPOWK3UQ==" crossorigin=""></script>
	<script src="https://cdn.maptiler.com/mapbox-gl-js/v1.5.1/mapbox-gl.js"></script>
	<script src="https://cdn.maptiler.com/mapbox-gl-leaflet/latest/leaflet-mapbox-gl.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.0.3/leaflet.css" />
	<link rel="stylesheet" href="https://cdn.maptiler.com/mapbox-gl-js/v1.5.1/mapbox-gl.css" />
</head>
	<style>html, body {
		width: 100%;
		height: 100%;
		margin: 0;
		padding: 0;}
	</style>
	<style>#map{
		position: relative;
		width: 100.0%;
		height: 100.0%;
		left: 0.0%;
		top: 0.0%;
		}
	</style>
</head>
<body>
	<div id="map"></div>
	<script>var geojson={% if geojson %}{{geojson | tojson}}{% else %}null{% endif %}</script>
	<script type="text/javascript">
	function onEachFeature(feature, layer) {
		var popupContent = '';
		for (const key in feature.properties) {
			if (feature.properties.hasOwnProperty(key)) {
				popupContent += feature.properties[key];
				layer.bindPopup(popupContent);
			}
		}
	}
	function pointToLayerNode(feature, latlng) {
		let fillColorValue = 'gray';
		if (feature.properties['pointColor']){
			fillColorValue = feature.properties['pointColor'];
		}
		return L.circleMarker(latlng, {
			radius: 2,
			fillColor: fillColorValue,
			color: "#000",
			weight: 1,
			opacity: 1,
			fillOpacity: 0.8
		});
	}

	function lineStyle(feature){
		if (feature.geometry['type'] == 'LineString'){
			if (feature.properties.edgeColor){
				return {
					"color": feature.properties.edgeColor
				}
			}
			else{
				return {
					"color": "black"
				}
			}
		}
		else if (feature.geometry['type'] == 'Polygon'){
			return {
				"color": "blue"
			}
		}
	}
	geojsonLayer = L.geoJSON(false, {
				pointToLayer: pointToLayerNode,
				onEachFeature: onEachFeature,
				style: lineStyle,
			});
	geojson.features.forEach(function(feature){
		if (feature.geometry['type'] == 'Point'){
			geojsonLayer.addData(feature);
		}
		else if (feature.geometry['type'] == 'LineString'){
			geojsonLayer.addData(feature);
		}
		else if (feature.geometry['type'] == 'Polygon'){
			geojsonLayer.addData(feature);
		}
	});
	var bounds = geojsonLayer.getBounds();
	// Forcing of canvas renderer:
	var map = L.map('map', {renderer: L.canvas()}).fitBounds(bounds);
	// Optional SVG Renderer:
	// var map = L.map('map').fitBounds(bounds);
	var esri_images = L.esri.basemapLayer('Imagery').addTo(map);
	var topo = L.esri.basemapLayer('Streets');
	var blank = L.tileLayer('');
	var gl = L.mapboxGL({
		attribution: "",
		style: 'https://api.maptiler.com/maps/basic/style.json?key=WOwRKyy0L6AwPBuM4Ggj'
	});
	var layerControl = L.control.layers(
		{
			'Satellite': esri_images,
			'Streets': gl,
			'Topo': topo,
			'Blank': blank
		},
		{},
		{
			position: 'topleft',
			collapsed: false		
		}
	).addTo(map);	
	mapLink = '<a href="http://openstreetmap.org">OpenStreetMap</a>';
	L.control.scale().addTo(map);
	geojsonLayer.addTo(map);
</script>
</body>
</html>